-#!/bin/bash
-
-USE_GLOW=true
-if ! command -v glow &>/dev/null; then
- echo "Glow not found, markdown rendering not available."
- echo "Output will be raw markdown and might look weird."
- echo "Install glow for easier reading & copy-paste."
- USE_GLOW=false
+#!/usr/bin/env sh
+
+USE_GLOW=false
+USE_BAT=false
+if command -v glow >/dev/null 2>/dev/null; then
+ USE_GLOW=true
+elif command -v bat >/dev/null 2>/dev/null; then
+ USE_BAT=true
+ printf "Glow not found, markdown rendering will be done by bat.\n"
+ printf "Install glow for easier reading & copy-paste.\n"
+else
+ printf "Glow or bat not found, markdown rendering not available.\n"
+ printf "Output will be raw markdown and might look weird.\n"
+ printf "Install glow for easier reading & copy-paste.\n"
fi
unalias -a
HELPSTRING="""\
- \e[37;45;1mxdg-ninja\e[0m
+ \033[37;45;1mxdg-ninja\033[0m
- \e[1;3mCheck your \$HOME for unwanted files.\e[1;0m
+ \033[1;3mCheck your \$HOME for unwanted files.\033[1;0m
────────────────────────────────────
- \e[3m--help\e[0m \e[1mThis help menu\e[0m
- \e[3m-h\e[0m
+ \033[3m--help\033[0m \033[1mThis help menu\033[0m
+ \033[3m-h\033[0m
- \e[3m--no-skip-ok\e[0m \e[1mDisplay messages for all files checked (verbose)\e[0m
- \e[3m-v\e[0m
+ \033[3m--no-skip-ok\033[0m \033[1mDisplay messages for all files checked (verbose)\033[0m
+ \033[3m-v\033[0m
- \e[3m--skip-ok\e[0m \e[1mDon't display anything for files that do not exist (default)\e[0m
+ \033[3m--skip-ok\033[0m \033[1mDon't display anything for files that do not exist (default)\033[0m
"""
SKIP_OK=true
for i in "$@"; do
- if [[ $i == "--help" ]] || [[ $i == "-h" ]]; then
- echo -e "$HELPSTRING"
+ if [ "$i" = "--help" ] || [ "$i" = "-h" ]; then
+ printf "%b" "$HELPSTRING"
exit
- elif [[ $i == "--skip-ok" ]]; then
+ elif [ "$i" = "--skip-ok" ]; then
SKIP_OK=true
- elif [[ $i == "--no-skip-ok" ]]; then
+ elif [ "$i" = "--no-skip-ok" ]; then
SKIP_OK=false
- elif [[ $i == "-v" ]]; then
+ elif [ "$i" = "-v" ]; then
SKIP_OK=false
fi
done
-if ! command -v jq &>/dev/null; then
- echo "jq is needed to run this script, but it wasn't found. Please install it to be able to use this script."
+if [ -z "${XDG_DATA_HOME}" ]; then
+ printf '\033[1;36m%s\033[1;0m\n' "The \$XDG_DATA_HOME environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf "\033[1;36m ⤷ \033[1mThe recommended value is: \033[1;3m\$HOME/.local/share\033[1;0m\n"
+fi
+if [ -z "${XDG_CONFIG_HOME}" ]; then
+ printf '\033[1;36m%s\033[1;0m\n' "The \$XDG_CONFIG_HOME environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf "\033[1;36m ⤷ \033[1mThe recommended value is: \033[1;3m\$HOME/.config\033[1;0m\n"
+fi
+if [ -z "${XDG_STATE_HOME}" ]; then
+ printf '\033[1;36m%s\033[1;0m\n' "The \$XDG_STATE_HOME environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf "\033[1;36m ⤷ \033[1mThe recommended value is: \033[1;3m\$HOME/.local/state\033[1;0m\n"
+fi
+if [ -z "${XDG_CACHE_HOME}" ]; then
+ printf '\033[1;36m%s\033[1;0m\n' "The \$XDG_CACHE_HOME environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf "\033[1;36m ⤷ \033[1mThe recommended value is: \033[1;3m\$HOME/.cache\033[1;0m\n"
+fi
+if [ -z "${XDG_RUNTIME_DIR}" ]; then
+ printf '\033[1;36m%s\033[1;0m\n' "The \$XDG_RUNTIME_DIR environment variable is not set, make sure to add it to your shell's configuration before setting any of the other environment variables!"
+ printf "\033[1;36m ⤷ \033[1mThe recommended value is: \033[1;3m/run/user/\$UID\033[1;0m\n"
+fi
+
+if ! command -v jq >/dev/null 2>/dev/null; then
+ printf "jq is needed to run this script, but it wasn't found. Please install it to be able to use this script.\n"
exit
fi
-# Function to expand enviornment variables in string
+printf "\n"
+
+# Function to expand environment variables in string
# https://stackoverflow.com/a/20316582/11110290
apply_shell_expansion() {
- declare data="$1"
- declare delimiter="__apply_shell_expansion_delimiter__"
- declare command="cat <<$delimiter"$'\n'"$data"$'\n'"$delimiter"
+ data="$1"
+ delimiter="__apply_shell_expansion_delimiter__"
+ command=$(printf "cat <<%s\n%s\n%s" "$delimiter" "$data" "$delimiter")
eval "$command"
}
# Returns 0 if the path doesn't lead anywhere
# Return 1 if the path points to a file, 2 if it points to a directory
-check_not_exists_file() {
+check_if_file_exists() {
FILE_PATH=$(apply_shell_expansion "$1")
- if [ -f "$FILE_PATH" ]; then
+ if [ -e "$FILE_PATH" ]; then
return 1
- elif [ -d "$FILE_PATH" ]; then
- return 2
else
return 0
fi
case "$MODE" in
ERR)
- printf '[\e[1;31m%s\e[1;0m]: \e[1;3m%s\e[1;0m\n' "$NAME" "$FILENAME"
+ printf '[\033[1;31m%s\033[1;0m]: \033[1;3m%s\033[1;0m\n' "$NAME" "$FILENAME"
;;
WARN)
- printf '[\e[1;33m%s\e[1;0m]: \e[1;3m%s\e[1;0m\n' "$NAME" "$FILENAME"
+ printf '[\033[1;33m%s\033[1;0m]: \033[1;3m%s\033[1;0m\n' "$NAME" "$FILENAME"
;;
INFO)
- printf '[\e[1;36m%s\e[1;0m]: \e[1;3m%s\e[1;0m\n' "$NAME" "$FILENAME"
+ printf '[\033[1;36m%s\033[1;0m]: \033[1;3m%s\033[1;0m\n' "$NAME" "$FILENAME"
;;
SUCS)
[ "$SKIP_OK" = false ] &&
- printf '[\e[1;32m%s\e[1;0m]: \e[1;3m%s\e[1;0m\n' "$NAME" "$FILENAME"
+ printf '[\033[1;32m%s\033[1;0m]: \033[1;3m%s\033[1;0m\n' "$NAME" "$FILENAME"
;;
HELP)
if $USE_GLOW; then
- echo "$HELP" | glow -
+ printf "%s\n" "$HELP" | glow -
+ elif $USE_BAT; then
+ printf "%s\n" "$HELP" | bat -pp --decorations=always --color=always --language markdown
else
- echo "$HELP"
+ printf "%s\n" "$HELP"
fi
;;
# Checks that the given file does not exist, otherwise outputs help
check_file() {
- INPUT="$1"
- NAME="$2"
-
- FILENAME=$(echo -E "$INPUT" | jq -r .path)
- MOVABLE=$(echo -E "$INPUT" | jq -r .movable)
- HELP=$(echo -E "$INPUT" | jq -r .help)
+ NAME="$1"
+ FILENAME="$2"
+ MOVABLE="$3"
+ HELP="$4"
- check_not_exists_file "$FILENAME"
+ check_if_file_exists "$FILENAME"
case $? in
log SUCS "$NAME" "$FILENAME" "$HELP"
;;
- 1 | 2)
+ 1)
if "$MOVABLE"; then
log ERR "$NAME" "$FILENAME" "$HELP"
else
esac
}
+decode_string() {
+ tmp="${1#\"}" # Trim leading quote
+ tmp="${tmp%\"}" # Trim traling quote
+ printf "%s" "$(echo "$tmp" | sed -e 's/\\n/\
+/g' -e 's/\\\"/\"/g')" # Replace \n with literal newline and \" with "
+}
+
# Reads a file from programs/, calls check_file on each file specified for the program
check_program() {
- INPUT=$1
-
- NAME=$(echo "$INPUT" | jq -r .name)
-
- while IFS= read -r file; do
- check_file "$file" "$NAME"
- done <<<"$(echo "$INPUT" | jq -rc '.files[]')"
+ PROGRAM=$1
+
+ while IFS="
+" read -r name; read -r filename; read -r movable; read -r help; do
+ check_file "$(decode_string "$name")" "$(decode_string "$filename")" "$movable" "$(decode_string "$help")"
+ done <<EOF
+$(jq '.files[] as $files | .name, $files.path, $files.movable, $files.help' "$PROGRAM")
+EOF
}
# Loops over all files in the programs/ directory and calls check_program
enumerate_programs() {
- echo -e "\e[1;3mStarting to check your \e[1;36m\$HOME.\e[1;0m"
- echo -e ""
- for prog_filename in ./programs/*; do
- check_program "$(cat "$prog_filename")"
+ printf "\033[1;3mStarting to check your \033[1;36m\$HOME.\033[1;0m\n"
+ printf "\n"
+ for prog_filename in "$(dirname "$0")"/programs/*; do
+ check_program "$prog_filename"
done
- echo -e "\e[1;3mDone checking your \e[1;36m\$HOME.\e[1;0m"
- echo -e ""
- echo -e "\e[3mIf you have files in your \e[1;36m\$HOME\e[1;0m that shouldn't be there, but weren't recognised by xdg-ninja, please consider creating a configuration file for it and opening a pull request on github.\e[1;0m"
- echo -e ""
+ printf "\033[1;3mDone checking your \033[1;36m\$HOME.\033[1;0m\n"
+ printf "\n"
+ printf "\033[3mIf you have files in your \033[1;36m\$HOME\033[1;0m that shouldn't be there, but weren't recognised by xdg-ninja, please consider creating a configuration file for it and opening a pull request on github.\033[1;0m\n"
+ printf "\n"
}
enumerate_programs